//+------------------------------------------------------------------+
//|                                                    TripleBBB.mq4 |
//|                                Copyright 2015, forexbob@live.com |
//|                                                forexbob@live.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, forexbob@live.com"
#property link      "forexbob@live.com"
#property version   "1.00"
#property strict
//--- input parameters

extern string   Trade_Box_Settings = "Inputs";
extern int      Trade_Minimum      =       20;
extern int      Trade_Maximum      =      100;
extern int      Box_Range          =        2;
extern int      Inside_Range       =        6;
extern color    Trade_Box_Color    = clrGreen;
extern string   Money_Management   = "Inputs";
extern int      Used_Leverage      =        5;
extern double   Account_Risk       =      1.0;
extern string   Trade_Management   = "Inputs";
extern int      MagicNumber        =     1001;
extern int      Slippage           =       50;
extern string   Trading_Sessions   =    "GMT";
extern int      AsianOpen          =        0;
extern int      AsianClose         =        6;
extern int      EuropeOpen         =        6;
extern int      EuropeClose        =       12;
extern int      LondonOpen         =       12;
extern int      LondonClose        =       18;
extern int      NewYorkOpen        =       18;
extern int      NewYorkClose       =       24;

//+------------------------------------------------------------------+
//| Global variables                                                 |
//+------------------------------------------------------------------+
datetime currentbar;

bool     InTheMarket,LookForTradeBoxes;

bool     OnPrimaryTrade,OnFirstHedge,OnSecondHedge,OnThirdHedge;
int      PrimaryOrderType,FirstHedgeOrderType,SecondHedgeOrderType,ThirdHedgeOrderType;
double   PrimaryOrderLotSize;

double   TMinRV,TMaxRY; //--- Trigger box minimum range value, Trigger box maximum range value

int      TBSP; //--- Trade box start point
int      TInsRange; //--- Trade box minimum inside range bars

datetime TradeStartPointDate; //--- Datetime trigger box start point
datetime initTimeT; // initiate time triger boxes

double   LTBH,LTBL,PTBH,PTBL; //--- Last trigger box high, last trigger box low

int      trade_box_no; //--- box name number

bool     NewTradeBox,LookForMarketEntry,MarketTrendingLong,MarketTrendingShort; // bool true if new trigger box has formed;

double   TradeBoxHigh,TradeBoxLow,TradeBoxRange,TradeProfitTarget,TradeCloseTarget; //--- trade entry, stops and profit levels

int      slippage,Magic2,Magic3,Magic4;
double   Volatility;

bool     GoLongIntoMarket;
bool     GoShortIntoMarket;
//+------------------------------------------------------------------+
//| initialization function of the expert                            |
//+------------------------------------------------------------------+
int init()
//+------------------------------------------------------------------+
  {
   TMinRV      = Trade_Minimum * Point;
   TMaxRY      = Trade_Maximum * Point;

   TBSP=Box_Range+Inside_Range+1;

   TradeStartPointDate=Time[TBSP];

   trade_box_no=0;

   NewTradeBox        = false;
   LookForMarketEntry = false;
   MarketTrendingLong = false;
   MarketTrendingLong = false;

   GoLongIntoMarket   = false;
   GoShortIntoMarket  = false;

   currentbar  = 0;
   slippage    = Slippage;
   Magic2      = MagicNumber+1;
   Magic3      = MagicNumber+2;
   Magic4      = MagicNumber+3;

   start();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   return (0);
  }
//+------------------------------------------------------------------+
//|   the main function of the expert                                |
//+------------------------------------------------------------------+
int start()
//+------------------------------------------------------------------+
  {
//---Set variables
   datetime time_current = TimeGMT();
   datetime thisbar      = Time[0];

   int      time_minute  = TimeMinute(time_current);
   int      time_hour    = TimeHour(time_current);
   int      day_of_week  = TimeDayOfWeek(time_current);

//+------------------------------------------------------------------+
//|   Trade Logic                                                    |
//+------------------------------------------------------------------+
//--- Activate trading hours
   bool tradetrue=((time_hour>=AsianOpen && time_hour<AsianClose) || 
                   (time_hour>=EuropeOpen && time_hour<EuropeClose)||
                   (time_hour>=LondonOpen && time_hour<LondonClose)||
                   (time_hour>=NewYorkOpen && time_hour<NewYorkClose));

   if(currentbar!=thisbar)//--- New bar detector
     {
      currentbar=thisbar;
      ScanForTriggerBoxes();
      CheckMarketDirections();//---Check Market Direction
     }

//---Check if in the markets 
   CheckInTheMarket();

//--- If order/s exists in the market - Collect primary order details
   if(InTheMarket)
     {
      ManagePrimaryTrade();//--- Manage primary trade
      if(OnFirstHedge) ManageSecondTrade();//--- Manage second trade
      if(OnSecondHedge) ManageThirdTrade();//--- Manage second trade
     }

   else
     {
      if(NewTradeBox) MakeTradeCalculations();

      if(LookForMarketEntry) WaitForBoxBreak();//---4th function
     }

//---Set first order to go long into market
   if(GoLongIntoMarket && tradetrue) EnterLong();

//---Set first order to go short into market
   if(GoShortIntoMarket && tradetrue) EnterShort();

   return(0);
  }
//+----------------------------------------+
//  Check if in the markets                |
//+----------------------------------------+
void CheckInTheMarket()
//+----------------------------------------+
  {
   InTheMarket=false;

   OnPrimaryTrade   = false;
   OnFirstHedge     = false;
   OnSecondHedge    = false;
   OnThirdHedge     = false;

   int orders_total=OrdersTotal();

   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber) continue;
           {
            InTheMarket=true;
            OnPrimaryTrade=true;
            PrimaryOrderType      = OrderType();
            PrimaryOrderLotSize   = OrderLots();

            break;
           }
        }
     }

   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic2) continue;
           {
            OnFirstHedge=true;
            FirstHedgeOrderType      = OrderType();
            break;
           }
        }
     }

   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic3) continue;
           {
            OnSecondHedge=true;
            SecondHedgeOrderType      = OrderType();
            break;
           }
        }
     }
   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic4) continue;
           {
            OnThirdHedge=true;
            break;
           }
        }
     }
  }
//+----------------------------------------+
//  Manage primary trade                   |
//+----------------------------------------+
void ManagePrimaryTrade()
//+----------------------------------------+
  {
   if(PrimaryOrderType==0) //Long trade
     {
      double profitTarget = TradeBoxHigh + TradeBoxRange;
      double HedgeClose   = TradeBoxLow - TradeBoxRange;
      
      if(!OnFirstHedge) bool PlaceFirstHedge=OrderSend(Symbol(),OP_SELLSTOP,(PrimaryOrderLotSize*3),TradeBoxLow,slippage,0,0,NULL,Magic2,0,Red);
      if(Bid>profitTarget)
        {
         CloseAllTrades();
         CloseAllPending();
        }
      if(Ask<HedgeClose)
        {
         CloseAllTrades();
         CloseAllPending();
        }
     }

   if(PrimaryOrderType==1) //Short trade
     {
      double profitTarget = TradeBoxLow - TradeBoxRange;
      double HedgeClose   = TradeBoxHigh + TradeBoxRange;
      
      if(!OnFirstHedge) bool PlaceFirstHedge=OrderSend(Symbol(),OP_BUYSTOP,(PrimaryOrderLotSize*3),TradeBoxHigh,slippage,0,0,NULL,Magic2,0,Blue);
      if(Ask<profitTarget)
        {
         CloseAllTrades();
         CloseAllPending();
        }
      if(Bid>HedgeClose)
        {
         CloseAllTrades();
         CloseAllPending();
        }
     }
  }
//+----------------------------------------+
//  Manage second trade                    |
//+----------------------------------------+
void ManageSecondTrade()
//+----------------------------------------+
  {
   if(FirstHedgeOrderType==1) //Short first hedge trade
     {
      if(!OnSecondHedge) bool PlaceSecondHedge=OrderSend(Symbol(),OP_BUYSTOP,(PrimaryOrderLotSize*6),TradeBoxHigh,slippage,0,0,NULL,Magic3,0,Blue);
     }

   if(FirstHedgeOrderType==0) //Long first hedge trade
     {
      if(!OnSecondHedge) bool PlaceSecondHedge=OrderSend(Symbol(),OP_SELLSTOP,(PrimaryOrderLotSize*6),TradeBoxLow,slippage,0,0,NULL,Magic3,0,Red);
     }
  }
  
//+----------------------------------------+
//  Manage Third trade                    |
//+----------------------------------------+
void ManageThirdTrade()
//+----------------------------------------+
  {
   if(SecondHedgeOrderType==0) //Long second hedge trade
     {
      if(!OnThirdHedge) bool PlaceThirdHedge=OrderSend(Symbol(),OP_SELLSTOP,(PrimaryOrderLotSize*12),TradeBoxLow,slippage,0,0,NULL,Magic4,0,Red);
     }

   if(SecondHedgeOrderType==1) //Short second hedge trade
     {
      if(!OnThirdHedge) bool PlaceThirdHedge=OrderSend(Symbol(),OP_BUYSTOP,(PrimaryOrderLotSize*12),TradeBoxHigh,slippage,0,0,NULL,Magic4,0,Blue);
     }
  }
//+-------------------------------------------------+
//  Scan for Box Patterns                           |
//+-------------------------------------------------+
void ScanForTriggerBoxes()
//+-------------------------------------------------+
  {
   if(initTimeT!=Time[0])
     {
      initTimeT=Time[0];

      TBSP=iBarShift(NULL,0,TradeStartPointDate);

      if(TBSP>(Box_Range+Inside_Range))
        {
         for(int i=TBSP; i>0; i--)
           {
            bool valid=true;
            int bc=0;

            double outH = High[iHighest(NULL,0,MODE_HIGH,Box_Range,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW, Box_Range,i)];
              {
               TradeStartPointDate=Time[i];
               continue;
              }

            for(int x=i-1;x>0;x--)
              {
               if(High[x]>outH)
                 {
                  valid=false;
                  break;
                 }
               else if(Low[x]<outL)
                 {
                  valid=false;
                  break;
                 }
               bc++;
              }

            if(valid && bc>=Inside_Range)
              {
               if(LTBH==outH || LTBL==outL)
                 {
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Box_Range-1],outH,Time[1],outL,Trade_Box_Color);
                  deleteanddrawbox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,Trade_Box_Color);
                  LTBH = outH;
                  LTBL = outL;
                 }
               else
                 {
                  NewTradeBox=true;
                  trade_box_no++;
                  PTBH = LTBH;
                  PTBL = LTBL;

                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"",Time[i+Box_Range-1],outH,Time[1],outL,Trade_Box_Color);
                  drawBox("Trigger_Box"+IntegerToString(trade_box_no)+"A",Time[i],outH,Time[1],outL,Trade_Box_Color);
                  LTBH = outH;
                  LTBL = outL;
                 }
               break;
              }
            else TradeStartPointDate=Time[i];
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| Check for market directio                                        |
//+------------------------------------------------------------------+
void CheckMarketDirections()
//+------------------------------------------------------------------+
  {
   if(LTBH>PTBH && LTBL>PTBL)
     {
      MarketTrendingLong=true;
      MarketTrendingShort=false;
     }
   else if(LTBH<PTBH && LTBL<PTBL)
     {
      MarketTrendingLong  = false;
      MarketTrendingShort = true;
     }
   else
     {
      MarketTrendingLong  = false;
      MarketTrendingShort = false;
     }
  }
//+----------------------------------------+
//  Look for market entry                  |
//+----------------------------------------+
void WaitForBoxBreak()
//+----------------------------------------+
  {
//---Reset variables
//---Initiate Function variables

//---Function Logic
   if(MarketTrendingLong)
     {
      double EntryTarget = TradeBoxHigh;
      double CancelEntry = TradeBoxLow;

      if(Bid>EntryTarget) GoLongIntoMarket=true;
      if(Bid<CancelEntry) MarketTrendingLong = false;
     }
   if(MarketTrendingShort)
     {
      double EntryTarget = TradeBoxLow;
      double CancelEntry = TradeBoxHigh;

      if(Bid<EntryTarget) GoShortIntoMarket = true;
      if(Bid>CancelEntry) MarketTrendingShort = false;
     }
//---Variable adjustments
  }
//+------------------------------------------------------------------+
//|   Set order to go long into market                               |
//+------------------------------------------------------------------+
void EnterLong()
//+------------------------------------------------------------------+
  {
//---Reset variables
   GoLongIntoMarket   = false;
   LookForMarketEntry = false;

//---Initiate Function variables
 double lot            =0.01;
 double n              = NormalizeDouble((TradeBoxRange / Point), 0);
 double tickvalue      = MarketInfo(Symbol(),MODE_TICKVALUE);
 double DollarValue    = NormalizeDouble(n * MarketInfo(Symbol(),MODE_TICKVALUE),2);
 double risk           = NormalizeDouble(AccountBalance()*(Account_Risk / 100),2);
 double tradevolume    = NormalizeDouble((risk /DollarValue),2);
 double TradeUnit      = tradevolume;

//---Function Logic
   if(TradeUnit>lot) lot=TradeUnit;

   int  OpenLong=OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,0,0,NULL,MagicNumber,0,Blue);

//---Variable adjustments
  }
//+------------------------------------------------------------------+
//|   Set order to go short into market                              |
//+------------------------------------------------------------------+
void EnterShort()
//+------------------------------------------------------------------+
  {
//---Reset variables
   GoShortIntoMarket  = false;
   LookForMarketEntry = false;
//---Initiate Function variables
 double lot            =0.01;
 double n              = NormalizeDouble((TradeBoxRange / Point), 0);
 double tickvalue      = MarketInfo(Symbol(),MODE_TICKVALUE);
 double DollarValue    = NormalizeDouble(n * MarketInfo(Symbol(),MODE_TICKVALUE),2);
 double risk           = NormalizeDouble(AccountBalance()*(Account_Risk / 100),2);
 double tradevolume    = NormalizeDouble((risk /DollarValue),2);
 double TradeUnit      = tradevolume;

//---Function Logic
   if(TradeUnit>lot) lot=TradeUnit;

   int    OpenShort=OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,0,0,NULL,MagicNumber,0,Red);

//---Variable adjustments
  }
//+----------------------------------------+
//  Draw box                               |
//+----------------------------------------+
void drawBox(string name,datetime time1,double price1,datetime time2,double price2,color clr,bool background=false)
                                                                                                             //+----------------------------------------+
  {
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+----------------------------------------+
//  Delete and Draw box                    |
//+----------------------------------------+
void deleteanddrawbox(string name,datetime time1,double price1,datetime time2,double price2,color clr,bool background=false)
                                                                                                                      //+----------------------------------------+
  {
   ObjectDelete(name);
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_BACK,0);
  }
//+----------------------------------------------------------+
//  Make trade calculations                                  |
//+----------------------------------------------------------+
void MakeTradeCalculations()
//+----------------------------------------------------------+
  {
   NewTradeBox        = false;
   LookForMarketEntry = true;
   TradeBoxHigh       = LTBH;
   TradeBoxLow        = LTBL;
   TradeBoxRange      = LTBH - LTBL;
  }
//+----------------------------------------+
//  Close all Trades                       |
//+----------------------------------------+
void CloseAllTrades()
//+----------------------------------------+
  {
   TradeBoxHigh      = 0.0;
   TradeBoxLow       = 0.0;
   TradeBoxRange     = 0.0;
   TradeProfitTarget = 0.0;
   TradeCloseTarget  = 0.0;

   InTheMarket=false;
   NewTradeBox        = false;
   LookForMarketEntry = false;
   MarketTrendingLong = false;
   MarketTrendingLong = false;

   int orders_total=OrdersTotal();

   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol())
           {
            int    ticket = OrderTicket();
            int    type   = OrderType();
            double lots   = OrderLots();

            if(type==OP_BUY) bool closelong=OrderClose(ticket,lots,Bid,slippage,Red);
            else if(type==OP_SELL) bool closeshort=OrderClose(ticket,lots,Ask,slippage,Blue);
           }
        }
     }
  }
//+----------------------------------------+
//  Close all Pending                      |
//+----------------------------------------+
void CloseAllPending()
//+----------------------------------------+
  {
   int orders_total=OrdersTotal();

   for(int pos=orders_total-1;pos>=0;pos--)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol())
           {
            int ticket = OrderTicket();
            int type   = OrderType();

            if(type==OP_BUYSTOP) bool deletelong=OrderDelete(ticket,Red);
            else if(type==OP_SELLSTOP) bool deleteshort=OrderDelete(ticket,Blue);
           }
        }
     }
  }
//+------------------------------------------------------------------+
