//+------------------------------------------------------------------+
//|                                             BreakoutBox v1.0.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window
//--- input parameters
int      StartPoint        =  7;

input int      RangeBars         =  3;
input int      MinInsideBars     =  4;

input double   MinRangeValue     =  0.0;
input double   MaxRangeValue     =  0.0500;

input color    BoxColor          =  clrDodgerBlue;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int _sp;
datetime startPointDate;
int OnInit()
  {
//--- indicator buffers mapping
   if(StartPoint<(RangeBars+MinInsideBars+1))_sp = (RangeBars+MinInsideBars+1);
   else _sp = StartPoint;
   
   startPointDate = Time[_sp];
   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
datetime initTime;
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(Time[0]!=initTime)
   {
      _sp = iBarShift(NULL,0,startPointDate);
      if(_sp > RangeBars+MinInsideBars)
      { 
         for(int i = _sp;i>0;i--)
         {
            bool valid = true;
            int bc = 0;
            
            double outH = High[iHighest(NULL,0,MODE_HIGH,RangeBars,i)];
            double outL = Low [iLowest (NULL,0,MODE_LOW, RangeBars,i)];
            
            if(outH-outL<MinRangeValue || outH-outL>MaxRangeValue)
            {
               ObjectDelete("B1"); ObjectDelete("B2");
                
               startPointDate = Time[i];
               continue;
            }   
            Print("---");
            
            for(int x = i-1;x>0;x--)
            {
               if(High[x]>outH)
               {
                   
                  valid = false;
                  break;
               }
               else if(Low[x]<outL)
               {
                  
                  valid = false;
                  break;
               }
               bc++;   
            } 
            
             
            
            if(valid && bc >= MinInsideBars)
            {
               drawBox("B1",Time[i], outH, Time[i+RangeBars-1], outL);
               drawBox("B2",Time[i], outH, Time[1], outL);
               break;
            }
            else 
            {
                
                startPointDate = Time[i];
                ObjectDelete("B1"); 
                ObjectDelete("B2");
            }
           
         }  
      }
      initTime = Time[0];    
    }

   return(rates_total);
  }
//+------------------------------------------------------------------+

void drawBox(string name,datetime time1, double price1, datetime time2, double price2, bool background=false)
{
     
   ObjectDelete(name);
   ObjectCreate(name,OBJ_RECTANGLE,0,time1,price1,time2,price2);
   ObjectSet(name,OBJPROP_COLOR, BoxColor);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_BACK,0);
}

